import unittest
from myCopyMatrix import copyMatrix

class CopyTest(unittest.TestCase):

  def setUp(self):
    self._model = [ [1,2,3,4], [5,6,7,8], [9,10,11,12] ]
    self._copy = copyMatrix(self._model)

  def testLength(self):
    self.assertEqual(len(self._model), len(self._copy))
    for k in range(len(self._model)):
      self.assertEqual(len(self._model[k]), len(self._copy[k]))

  def testEquivalence(self):
    self.assertEqual(self._model, self._copy)

  def testAddRow(self):
    self._copy.append([13,14,15,16])
    self.assertEqual(len(self._copy), 1+len(self._model))

  def testAddColumn(self):
    for k in range(len(self._model)):
      self._copy[k].append(k)
      self.assertEqual(len(self._copy[k]), 1+len(self._model[k]))
    self.assertEqual(len(self._copy), len(self._model))

  def testModifications(self):
    for r in range(len(self._copy)):
      for c in range(len(self._copy[r])):
        self._copy[r][c] *= 2

    for r in range(len(self._copy)):
      for c in range(len(self._copy[r])):
        self.assertEquals(self._copy[r][c], 2*self._model[r][c])
        

if __name__ == '__main__':
  unittest.main()
