import unittest
from Point import Point
from copyPoints import copyPoints

class CopyTest(unittest.TestCase):

  def setUp(self):
    self._model = [Point(3,4), Point(1,2), Point(10,5), Point(1,2)]
    self._copy = copyPoints(self._model)

  def testLength(self):
    self.assertEqual(len(self._model), len(self._copy))

  def testEquivalence(self):
    for k in range(len(self._model)):
      self.assertEqual(self._model[k], self._copy[k])

  def testSeparateList(self):
    self._copy.append(Point(3,5))
    self.assertEqual(len(self._copy), 1+len(self._model))

  def testSeparatePoints(self):
    for k in range(len(self._model)):
      self._copy[k].scale(2)
      self.assertEqual(self._copy[k].getX(), 2 * self._model[k].getX())
      self.assertEqual(self._copy[k].getY(), 2 * self._model[k].getY())


if __name__ == '__main__':
  unittest.main()
